"use strict";

this.name = "dredger-market";
this.author = "spara";
this.license     = "CC BY-NC-SA 4.0"; 

//put the original defs here. no def means there's a zero market of that commodity
this.$originalDefs = {
      "food" : [0,0,50,2,0,0,0,0,0],
      "luxuries" : [0,0,40,-2,0,0,0,0,0],
      "computers" : [0,0,100,-2,0,0,0,0,0],
      "machinery" : [0,0,80,-2,0,0,0,0,0],
      "alloys" : [0,0,1,0,0,100,0,0,0],
      "minerals" : [0,0,16,-1,-1,85,3,3,0]
};

this.updateLocalCommodityDefinition = function(goodDefinition) {
	var commodity = goodDefinition.key;
	var oldDefs = this.$originalDefs[commodity];
	
	//define the market size for the station
	goodDefinition.capacity = 127;
	
	//old style definition found for the good. calculate it the old way
	if (oldDefs) {
		var market_base_price = oldDefs[2];
		var market_eco_adjust_price = oldDefs[3];
		var market_eco_adjust_quantity = oldDefs[4];
		var market_base_quantity = oldDefs[5];
		var market_mask_price = oldDefs[6];
		var market_mask_quantity = oldDefs[7];
		var market_rnd = Math.floor(Math.random() * 256);

		var economy = system.economy;
		
		var price = (market_base_price + (market_rnd & market_mask_price) + (economy * market_eco_adjust_price)) & 255;
		price *= 0.4;
		
		var quantity = (market_base_quantity + (market_rnd & market_mask_quantity) - (economy * market_eco_adjust_quantity)) & 255;
		if (quantity > 127) quantity = 0;
		
		quantity &= 63;
		
		goodDefinition.quantity = quantity;
		goodDefinition.price = price * 10;
	}
	//no definition found. no market on that commodity
	else {
		goodDefinition.price = 0;
		goodDefinition.quantity = 0;
		goodDefinition.capacity = 0;
	}
	//scale down if quantity too high
	if (goodDefinition.quantity > goodDefinition.capacity)
		goodDefinition.quantity = Math.floor(goodDefinition.quantity / 127 * goodDefinition.capacity);

	return goodDefinition;
};
